const Joi = require('joi');

module.exports = Joi.object({
  id: Joi.string(),
  makeId: Joi.string(),
  makeName: Joi.string(),
  makeCountry: Joi.string(),
  name: Joi.string(),
  trim: Joi.string().allow(''),
  year: Joi.number().integer(),
  body: Joi.string(),
  enginePosition: Joi.string(),
  engineCc: Joi.number(),
  engineCyl: Joi.number(),
  engineType: Joi.string(),
  engineValvesPerCyl: Joi.number(),
  enginePowerPs: Joi.number(),
  enginePowerRpm: Joi.number(),
  engineTorqueNm: Joi.number(),
  engineTorqueRpm: Joi.number(),
  engineBoreMm: Joi.number().allow(null),
  engineStrokeMm: Joi.number(),
  engineCompression: Joi.string(),
  engineFuel: Joi.string(),
  topSpeedKph: Joi.number().allow(null),
  zeroTo100Kph: Joi.number().allow(null),
  drive: Joi.string(),
  transmissionType: Joi.string(),
  seats: Joi.number().integer(),
  doors: Joi.number().integer(),
  weightKg: Joi.number(),
  lengthMm: Joi.number(),
  widthMm: Joi.number().allow(null),
  heightMm: Joi.number(),
  wheelbaseMm: Joi.number(),
  lkmHwy: Joi.number(),
  lkmMixed: Joi.number(),
  lkmCity: Joi.number(),
  fuelCapL: Joi.number(),
  soldInUs: Joi.number(),
  co2: Joi.number().allow(null),
  engineL: Joi.number(),
  engineCi: Joi.number(),
  engineBoreIn: Joi.number(),
  engineStrokeIn: Joi.number(),
  engineValves: Joi.number(),
  enginePowerHp: Joi.number(),
  enginePowerKw: Joi.number(),
  engineTorqueLbft: Joi.number(),
  engineTorqueKgm: Joi.number(),
  topSpeedMph: Joi.number(),
  weightLbs: Joi.number(),
  lengthIn: Joi.number(),
  widthIn: Joi.number(),
  heightIn: Joi.number(),
  wheelbaseIn: Joi.number(),
  mpgHwy: Joi.number(),
  mpgCity: Joi.number(),
  mpgMixed: Joi.number(),
  fuelCapG: Joi.number(),
  extColors: Joi.array(),
  intColors: Joi.array(),
}).rename('model_id', 'id')
  .rename('model_make_id', 'makeId')
  .rename('make_display', 'makeName')
  .rename('make_country', 'makeCountry')
  .rename('model_name', 'name')
  .rename('model_trim', 'trim')
  .rename('model_year', 'year')
  .rename('model_body', 'body')
  .rename('model_engine_position', 'enginePosition')
  .rename('model_engine_cc', 'engineCC')
  .rename('model_engine_cyl', 'engineCyl')
  .rename('model_engine_type', 'engineType')
  .rename('model_engine_valves_per_cyl', 'engineValuesPerCyl')
  .rename('model_engine_power_ps', 'enginePowerPs')
  .rename('model_engine_power_rpm', 'enginePowerRpm')
  .rename('model_engine_torque_nm', 'engineTorqueNm')
  .rename('model_engine_torque_rpm', 'engineTorqueRpm')
  .rename('model_engine_bore_mm', 'engineBoreMm')
  .rename('model_engine_stroke_mm', 'engineStroleMm')
  .rename('model_engine_compression', 'engineCompression')
  .rename('model_engine_fuel', 'engineFuel')
  .rename('model_top_speed_kph', 'topSpeedKph')
  .rename('model_0_to_100_kph', 'zeroTo100Kph')
  .rename('model_drive', 'drive')
  .rename('model_transmission_type', 'transmissionType')
  .rename('model_seats', 'seats')
  .rename('model_doors', 'doors')
  .rename('model_weight_kg', 'weightKg')
  .rename('model_length_mm', 'lengthMm')
  .rename('model_width_mm', 'widthMm')
  .rename('model_height_mm', 'heightMm')
  .rename('model_wheelbase_mm', 'wheelbaseMm')
  .rename('model_lkm_hwy', 'lkmHwy')
  .rename('model_lkm_mixed', 'lkmMixed')
  .rename('model_lkm_city', 'lkmCity')
  .rename('model_fuel_cap_l', 'fuelCapL')
  .rename('model_sold_in_us', 'soldInUs')
  .rename('model_co2', 'co2')
  .rename('model_engine_l', 'engineL')
  .rename('model_engine_ci', 'engineCi')
  .rename('model_engine_bore_in', 'engineBoreIn')
  .rename('model_engine_stroke_in', 'engineStrokeIn')
  .rename('model_engine_valves', 'engineValves')
  .rename('model_engine_power_hp', 'enginePowerHp')
  .rename('model_engine_power_kw', 'enginePowerKw')
  .rename('model_engine_torque_lbft', 'engineTorqueLbft')
  .rename('model_engine_torque_kgm', 'engineTorqueKgm')
  .rename('model_top_speed_mph', 'topSpeedMph')
  .rename('model_weight_lbs', 'weightLbs')
  .rename('model_length_in', 'lengthIn')
  .rename('model_width_in', 'widthIn')
  .rename('model_height_in', 'heightIn')
  .rename('model_wheelbase_in', 'wheelbaseIn')
  .rename('model_mpg_hwy', 'mpgHwyg')
  .rename('model_mpg_city', 'mpgCity')
  .rename('model_mpg_mixed', 'mpgMixed')
  .rename('model_fuel_cap_g', 'fuelCapG')
  .rename('ExtColors', 'extColors')
  .rename('IntColors', 'intColors');
